# Install Feast

A production deployment of Feast is deployed using Kubernetes.

## Kubernetes \(with Helm\)

This guide installs Feast into an existing Kubernetes cluster using Helm. The installation is not specific to any cloud platform or environment, but requires Kubernetes and Helm.

{% page-ref page="kubernetes-with-helm.md" %}

## Amazon EKS \(with Terraform\)

This guide installs Feast into an AWS environment using Terraform. The Terraform script is opinionated and intended to allow you to start quickly.

{% page-ref page="kubernetes-amazon-eks-with-terraform.md" %}

## Azure AKS \(with Helm\)

This guide installs Feast into an Azure AKS environment with Helm.

{% page-ref page="kubernetes-azure-aks-with-helm.md" %}

## Azure AKS \(with Terraform\)

This guide installs Feast into an Azure environment using Terraform. The Terraform script is opinionated and intended to allow you to start quickly.

{% page-ref page="kubernetes-azure-aks-with-terraform.md" %}

## Google Cloud GKE \(with Terraform\)

This guide installs Feast into a Google Cloud environment using Terraform. The Terraform script is opinionated and intended to allow you to start quickly.

{% page-ref page="google-cloud-gke-with-terraform.md" %}

## IBM Cloud Kubernetes Service \(IKS\) and Red Hat OpenShift \(using Kustomize\)

This guide installs Feast into an existing [IBM Cloud Kubernetes Service](https://www.ibm.com/cloud/kubernetes-service) or [Red Hat OpenShift on IBM Cloud](https://www.ibm.com/cloud/openshift) using Kustomize.

{% page-ref page="ibm-cloud-iks-with-kustomize.md" %}

